from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify
abcs = [
	'a',
	'b',
	'c',
	'd',
	'e',
	'f',
	'g',
	'h',
	'i',
	'j',
	'k',
	'l',
	'm',
	'n',
	'o',
	'p',
	'q',
	'r',
	's',
	't',
	'u',
	'v',
	'w',
	'x',
	'y',
	'z',
]
mdx = MDX('Macmillan-British-English-2019.mdx')
T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
Key_not_equal_to_headword = []
data_tuple = []

uk_more_than_1 = []
more_than_1uk_tags = []
for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	key_is_abc = True
	for X in Key.decode():
		if X.lower() not in abcs:
			key_is_abc = False
	if key_is_abc:
		if Value[:8] != b'@@@LINK=':
			Data = []
			bso = BeautifulSoup(Value.decode(),'lxml')
			try:
				bso.html.unwrap()
			except:
				None
			try:
				bso.head.unwrap()
			except:
				None
			try:
				bso.body.unwrap()
			except:
				None

			href_list = []
			for X in bso.select('.PRONS>a'):
				Y = X.attrs
				try:
					Z = Y['href']
				except:
					Z = False
				if Z:
					if Z[:8] == 'sound://':
						#'onclick':'new Audio(\''+Z[8:]+'\').play()'
						for child in X.children:
							try:
								src = child.attrs['src']
							except:
								src = False
						if src:
							if src.lower() == 'uk.png':
								the_new_tag = bso.new_tag('a', attrs={'href':Z,'class':['UK',],})
								the_new_tag.append(bso.new_string('M'))
								href_list.append(the_new_tag)
							elif src.lower() == 'us.png':
								the_new_tag = bso.new_tag('a', attrs={'href':Z,'class':['US',],})
								the_new_tag.append(bso.new_string('M'))
								href_list.append(the_new_tag)
						else:
							the_new_tag = bso.new_tag('a', attrs={'href':Z,})
							the_new_tag.append(bso.new_string('M'))
							href_list.append(the_new_tag)

			content_text = b''
			for X in href_list:
				content_text += X.encode()
			if content_text:
				minified = minify(content_text.decode())
				minified = minified.encode()
				data_tuple.append((Key,minified))
		elif Value[:8] == b'@@@LINK=':
			at_at_links.append((Key,Value))


if data_tuple:
	with open('1_isABC_and_extract.txt','wb') as fyle:
		for X in data_tuple:
			if X is not data_tuple[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		for X in at_at_links:
			if X is at_at_links[0]:
				fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			elif X is at_at_links[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')