from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify

mdx = MDX('1_isABC_decomposed.mdx')
T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
phonetic_data = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		Data_list = []
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None
		for X in bso.select('.gram>a'):
			X.decompose()

		for X in bso.select('.pos-header'):
			Y = X.select('.uk')
			'''
			if len(Y) == 0:
				X.decompose()#'''
			if len(Y) == 1:
				#
				class_within_posheader = []
				has_UK_after_US = False
				for Z in X.children:
					if isinstance(Z,type(bso.new_tag('x'))):
						tag_attrs = Z.attrs
						try:
							has_class = tag_attrs['class']
						except:
							has_class = False
						if has_class:
							class_within_posheader.append(has_class)
				if ['us'] in class_within_posheader:
					header_length = len(class_within_posheader)
					for list_index in range(header_length):
						if class_within_posheader[list_index] == ['us']:
							for after in class_within_posheader[list_index:-1]:
								if after == ['uk']:
									has_UK_after_US = True
				#
				pos_header_children = b''
				if has_UK_after_US:
					for to_decompose in X.select('.us'):
						to_decompose.decompose()
					Data_list.append(b'<span class="pos-header">' + X.encode() + b'</span>')
				else:
					for Z in X.children:
						if isinstance(Z,type(bso.new_tag('x'))):
							tag_attrs = Z.attrs
							try:
								has_class = tag_attrs['class']
							except:
								has_class = False
							if has_class:
								class_is_US = False
								for a_class in has_class:
									if a_class.lower() =='us':
										class_is_US = True
								if class_is_US:
									break
								else:
									pos_header_children += Z.encode()
							else:
								#class = blanks'
								pos_header_children += Z.encode()
					Data_list.append(b'<span class="pos-header">' + pos_header_children + b'</span>')

			elif len(Y) >1:
				Data_list.append(X.encode())#'''
		#'''
		if Data_list:
			Data = b''
			for X in Data_list:
				Data += X
			minified = minify(Data.decode())
			minified = minified.encode()
			phonetic_data.append((Key,minified))
	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))


if phonetic_data:
	with open('2_extracting.txt','wb') as fyle:
		for X in phonetic_data:
			if X is not phonetic_data[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		if at_at_links:
			for X in at_at_links:
				if X is at_at_links[0]:
					fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
				elif X is at_at_links[-1]:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
				else:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')