from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify
mdx = MDX('1_isABC_and_extract.mdx')

T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
data_tuple = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.head.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None

		a_list = []
		for X in bso.select('a'):
			if X.encode() not in a_list:
				a_list.append(X.encode())
		txt = b''
		if a_list:
			for X in a_list:
				txt += X
		if txt:
			minified = minify(txt.decode())
			minified = minified.encode()
			data_tuple.append((Key,minified))
	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))


if data_tuple:
	with open('2_remove_repeats_in_content.txt','wb') as fyle:
		for X in data_tuple:
			if X is not data_tuple[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		if at_at_links:
			for X in at_at_links:
				if X is at_at_links[0]:
					fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
				elif X is at_at_links[-1]:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
				else:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')