from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify
abcs = [
	'a',
	'b',
	'c',
	'd',
	'e',
	'f',
	'g',
	'h',
	'i',
	'j',
	'k',
	'l',
	'm',
	'n',
	'o',
	'p',
	'q',
	'r',
	's',
	't',
	'u',
	'v',
	'w',
	'x',
	'y',
	'z',
]
mdx = MDX('CambridgeOnline.mdx')
T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
Key_not_equal_to_headword = []
phonetic_data = []

uk_more_than_1 = []
more_than_1uk_tags = []
for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	key_is_abc = True
	for X in Key.decode():
		if X.lower() not in abcs:
			key_is_abc = False
	if key_is_abc:
		if Value[:8] != b'@@@LINK=':
			Data = []
			bso = BeautifulSoup(Value.decode(),'lxml')
			try:
				bso.html.unwrap()
			except:
				None
			try:
				bso.body.unwrap()
			except:
				None

			for X in bso.select('.pos-body'):
				X.decompose()
			for X in bso.select('.dataset'):
				X.decompose()

			minified = minify((bso.encode()).decode())
			minified = minified.encode()
			phonetic_data.append((Key,minified))
		elif Value[:8] == b'@@@LINK=':
			at_at_links.append((Key,Value))


if phonetic_data:
	with open('1_isABC_decomposed.txt','wb') as fyle:
		for X in phonetic_data:
			if X is not phonetic_data[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		for X in at_at_links:
			if X is at_at_links[0]:
				fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			elif X is at_at_links[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')