from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify

mdx = MDX('1_isABC_decomposed.mdx')
T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
phonetic_data = []
UK_after_US = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		Data_list = []
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None

		for X in bso.select('.pos-header'):
			class_within_posheader = []
			for Z in X.children:
				if isinstance(Z,type(bso.new_tag('x'))):
					tag_attrs = Z.attrs
					try:
						has_class = tag_attrs['class']
					except:
						has_class = False
					if has_class:
						class_within_posheader.append(has_class)
			if ['us'] in class_within_posheader:
				header_length = len(class_within_posheader)
				for list_index in range(header_length):
					if class_within_posheader[list_index] == ['us']:
						for after in class_within_posheader[list_index:-1]:
							if after == ['uk']:
								UK_after_US.append((b'[' + Key + b']', X.encode()))
		#'''
		if Data_list:
			Data = b''
			for X in Data_list:
				Data += X
			minified = minify(Data.decode())
			minified = minified.encode()
			phonetic_data.append((Key,minified))
	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))

if UK_after_US:
	with open('UK_after_US.txt','wb') as fyle:
		for X in UK_after_US:
			fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n')