from unicodedata import normalize
from readmdict import MDX
from pydub import AudioSegment
from pydub import effects
from bs4 import BeautifulSoup
import os
mdx = MDX('1_isABC_and_extract.mdx')

T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div

data_tuple = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.head.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None

		for X in bso.select('a'):
			attrs = X.attrs
			href = attrs['href']
			link = href[8:]
			source_file = '.\\SPXAudios\\'+link
			normalized = False
			if os.path.isfile(source_file):
				audio = AudioSegment.from_file(source_file)
				normalized = effects.normalize(audio)
			destinate_file = '.\\TheAudio\\'+link[:-3]+'mp3'
			if normalized:
				if not os.path.isfile(destinate_file):
					normalized.export(destinate_file,format='mp3',bitrate='128k')

'''
if data_tuple:
	with open('3_convert_+db.txt','wb') as fyle:
		for X in data_tuple:
			if X is not data_tuple[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
'''