from readmdict import MDX
from bs4 import BeautifulSoup
mdx = MDX('3_del_repeats_after_decomposed.mdx')

T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div

data_tuple = []
at_at_links = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None
		
		for X in bso.select('.headword'):
			Y = X.text
			Y = Y.strip()
			if Key == Y.encode():
				X.decompose()
		tag_a = bso.select('a')
		tag_ipa = bso.select('.ipa')

		if len(tag_a) == len(tag_ipa) and len(tag_a) == 1:
			the_attrs_dict = tag_a[0].attrs
			the_link = the_attrs_dict['href']#[8:], strip the 'sound://'
			the_new_tag = bso.new_tag('a', attrs={'class':['unique'],'href':the_link})
			wrapped = tag_ipa[0].wrap(the_new_tag)
			data_tuple.append((Key,wrapped.encode()))
		else:
			data_tuple.append((Key,bso.encode()))

	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))

if data_tuple:
	with open('5_one_mp3_one_ipa.txt','wb') as fyle:
		for X in data_tuple:
			if X is not data_tuple[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		if at_at_links:
			for X in at_at_links:
				if X is at_at_links[0]:
					fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
				elif X is at_at_links[-1]:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
				else:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')