from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify
mdx = MDX('5_one_mp3_one_ipa.mdx')

T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div

data_tuple = []
at_at_links = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None
		for X in bso.select('.gram'):
			if X.text.strip() == '':
				X.decompose()

		for X in bso.select('.pos'):
			try:
				has_parent_parent = (X.parent).parent
			except:
				has_parent_parent = False
			if has_parent_parent:
				Y = has_parent_parent.attrs
				try:
					has_class = Y['class']
				except:
					has_class = False
				if has_class:
					if 'pos-header' in has_class:
						None
					else:
						has_parent_parent.unwrap()
				elif Y != {}:
					has_parent_parent.unwrap()
			try:
				has_parent = X.parent
			except:
				has_parent = False
			if has_parent:
				Y = has_parent.attrs
				try:
					has_class = Y['class']
				except:
					has_class = False
				if has_class:
					if 'pos-header' in has_class:
						None
					else:
						has_parent.unwrap()
				else:
					has_parent.unwrap()

		for X in bso.select('.us a'):
			try:
				(X.parent).decompose()
			except:
				None
		for X in bso.select('.region'):
			try:
				X.unwrap()
			except:
				None
		for X in bso.select('.headword'):
			try:
				X.unwrap()
			except:
				None
		tag_a = bso.select('a')
		tag_ipa = bso.select('.ipa')
		if len(tag_a) > 1 or len(tag_ipa) > 1:
			href_list = []
			for X in tag_a:
				the_attrs_dict = X.attrs
				the_link = the_attrs_dict['href']#[8:], strip the 'sound://'
				if the_link not in href_list:
					href_list.append(the_link)
			ipa_text_list = []
			for X in tag_ipa:
				Y = X.text.strip()
				Y = Y.replace('.','')
				if Y not in ipa_text_list:
					ipa_text_list.append(Y)
			if len(href_list) == 1 and len(ipa_text_list) == 1:
				the_new_tag = bso.new_tag('a', attrs={'class':['unique'],'href':href_list[0]})
				wrapped = tag_ipa[0].wrap(the_new_tag)
				minified = minify((wrapped.encode()).decode())
				minified = '<link rel=stylesheet href=phonetics.css>' + minified
				data_tuple.append((Key,minified.encode()))
			else:
				minified = minify((bso.encode()).decode())
				minified = '<link rel=stylesheet href=phonetics.css>' + minified
				data_tuple.append((Key,minified.encode()))
		else:
			minified = minify((bso.encode()).decode())
			minified = '<link rel=stylesheet href=phonetics.css>' + minified
			data_tuple.append((Key,minified.encode()))

	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))

dict_data = []
for X in data_tuple:
	if X not in dict_data:
		dict_data.append(X)
for X in at_at_links:
	if X not in dict_data:
		dict_data.append(X)

if dict_data:
	with open('6_combine_same_mp3_ipa_into_one.txt','wb') as fyle:
		for X in dict_data:
			if X is not dict_data[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
