from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify
mdx = MDX('6_combine_same_mp3_ipa_into_one.mdx')

T = len(mdx)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
at_at_links = []
data_tuple = []
a_lessthan_ipa = []

for Key,Value in mdx.items():
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1
	Value = Value.strip()

	if Value[:8] != b'@@@LINK=':
		bso = BeautifulSoup(Value.decode(),'lxml')
		try:
			bso.html.unwrap()
		except:
			None
		try:
			bso.head.unwrap()
		except:
			None
		try:
			bso.body.unwrap()
		except:
			None
		for x in bso.select('.us>.pron'):
			try:
				x.unwrap()
			except:
				None
		for X in bso.select('.pos-header'):
			for Y in X.select('.ipa'):
				pre = Y.previous_sibling
				if pre.encode().strip() == b'/':
					pre.replace_with(bso.new_string('['))
				nex = Y.next_sibling
				if nex.encode().strip() == b'/':
					nex.replace_with(bso.new_string(']'))
		for Y in bso.select('.ipa'):
			pre = Y.previous_sibling
			try:
				if pre.encode().strip() == b'/':
					pre.replace_with(bso.new_string('['))
			except:
				None
			nex = Y.next_sibling
			try:
				if nex.encode().strip() == b'/':
					nex.replace_with(bso.new_string(']'))
			except:
				None
		#
		#this_ipa_has_error = False
		for X in bso.select('.pos-header'):
			the_pos_header_length = len(X.select('.pos-header'))#'recount' and 'sin' have innner .pos-header
			if the_pos_header_length == 0:
				for Y in X.select('.uk'):
					text_in_UK = Y.get_text()
					if text_in_UK.strip():
						#get A's href, get IPA right next to the A
						Z = Y.select('a')
						if len(Z) == 0:
							no_A_in_UK = True
						elif len(Z) == 1:
							#h_ref = Z[0].attrs['href']
							this_ipa = Y.select('.ipa')
							this_ipa[0].wrap(Z[0])
						else:
							print(Key)
					else:
						#get a's href, +div
						Z = Y.select('a')
						if len(Z) == 0:
							no_A_in_UK = True
						elif len(Z) == 1:
							#h_ref = Z[0].attrs['href']
							Z[0].append(bso.new_tag('div',attrs={'class':['uk_flag']}))
						else:
							print(Key)
			
			else:
				X.unwrap()
		#if no Audio at all, try combine IPA
		all_the_A_tag = bso.select('a')
		if len(all_the_A_tag) == 0:
			ipa_text_list = []
			IPA_list = []
			for X in bso.select('.ipa'):
				IPA_list.append(X)
				Y = X.get_text()
				Y = Y.strip()
				Y = Y.replace('.','')
				if Y not in ipa_text_list:
					ipa_text_list.append(Y)
			if len(ipa_text_list) == 1:
				IPA_list[0].attrs['class'] = ['none_a']
				Re_bso = b'<link rel=stylesheet href=phonetics.css>' + IPA_list[0].encode().strip()
				bso = BeautifulSoup(Re_bso.decode(),'lxml')
				try:
					bso.html.unwrap()
				except:
					None
				try:
					bso.head.unwrap()
				except:
					None
				try:
					bso.body.unwrap()
				except:
					None

		#repeats_in_dictionaries
		for X in bso.select('.us'):
			the_text = X.get_text()
			if the_text.strip() == '':
				X.decompose()
		texts = []
		for X in bso.select('.pos-header'):
			y = X.get_text()
			y = y.replace('.','')
			if y not in texts:
				texts.append(y)
			else:
				X.decompose()

		#unwrapp all .pos-header
		#'''
		for X in bso.select('.pos-header'):
			X.wrap(bso.new_tag('span',attrs={'class':['a_row']}))
			try:
				X.unwrap()
			except:
				None
		for X in bso.find_all():
			the_text = X.get_text()
			if the_text.strip() == '':
				if isinstance(X,type(bso.new_tag('xyz'))):
					if X.name == 'link':
						None
					elif X.name == 'a':
						has_UK_flag = False
						for Y in X.children:
							if isinstance(Y,type(bso.new_tag('xyz'))):
								Z = Y.attrs
								try:
									Z['class']
									has_UK_flag = True
								except:
									None
						if has_UK_flag:
							None
						else:
							Y = X.attrs
							z = Y['href'][:8]
							if z == 'sound://':
								None
							else:
								X.decompose()
					elif X.name == 'div':
						Y = X.attrs
						if Y['class'] == ['uk_flag',]:
							None
						else:
							X.decompose()
					else:
						X.unwrap()
				else:
					X.decompose()#'''
		#
		all_the_A_tag = bso.select('a')
		the_IPA = bso.select('.ipa')
		ipa_length = len(the_IPA)
		href_of_all_the_A_tag = []
		for X in all_the_A_tag:
			Y = X.attrs
			Z = Y['href']
			if Z not in href_of_all_the_A_tag:
				href_of_all_the_A_tag.append(Z)
		if len(href_of_all_the_A_tag) == 1 and ( ipa_length == 0 or ipa_length ==1 ):
			all_the_A_tag[0].attrs['class'] = ['unique']
			Re_bso = b'<link rel=stylesheet href=phonetics.css>' + all_the_A_tag[0].encode().strip()
			bso = BeautifulSoup(Re_bso.decode(),'lxml')
			try:
				bso.html.unwrap()
			except:
				None
			try:
				bso.head.unwrap()
			except:
				None
			try:
				bso.body.unwrap()
			except:
				None
		'''
		elif len(href_of_all_the_A_tag) == 1 and ipa_length > 1:# 1 A, and properly multi-accent
			all_the_A_tag[0].attrs['class'] = ['multi']
			txt_byte = all_the_A_tag[0].encode()
			txt_byte = txt_byte[:-4]
			ipa_into_A = txt_byte + the_IPA[0].encode() + b'</a>'
			Re_bso = b'<link rel=stylesheet href=phonetics.css>' + ipa_into_A.strip()
			tmp_list = []
			for X in the_IPA:
				if X is not the_IPA[0]:
					y = X.encode().strip()
					if y not in tmp_list:
						tmp_list.append(y)
						Re_bso += b'<span class=pron>['
						Re_bso += y
						Re_bso += b']</span>'
				else:
					y = X.encode().strip()
					tmp_list.append(y)
			bso = BeautifulSoup(Re_bso.decode(),'lxml')
			try:
				bso.html.unwrap()
			except:
				None
			try:
				bso.head.unwrap()
			except:
				None
			try:
				bso.body.unwrap()
			except:
				None#'''
		#
		has_text = bso.get_text()
		has_text = has_text.strip()
		A_length = len(bso.select('a'))
		if has_text or A_length > 0 :
			minified = minify((bso.encode()).decode())
			data_tuple.append((Key,minified.encode()))

	elif Value[:8] == b'@@@LINK=':
		at_at_links.append((Key,Value))

#'''
if data_tuple:
	with open('7_[].txt','wb') as fyle:
		for X in data_tuple:
			if X is not data_tuple[-1]:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
			else:
				fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
		if at_at_links:
			for X in at_at_links:
				if X is at_at_links[0]:
					fyle.write(b'\r\n' + X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')
				elif X is at_at_links[-1]:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>')
				else:
					fyle.write(X[0] + b'\r\n' + X[1] + b'\r\n</>\r\n')

'''
if a_lessthan_ipa:
	with open('a_in_UK_errors.txt','wb') as fyle:
		for x in a_lessthan_ipa:
			fyle.write(x + b'\r\n')#'''